Summary: high-performance, distributed memory object caching system
Summary(ko): 높은 성능의 메모리 기반 캐싱 시스템
Name: memcached
Version: 1.5.7
Release: 1%{?dist}
Epoch: 1
License: BSD
Group: System Environment/Daemons
Source0: http://www.memcached.org/files/memcached-%{version}.tar.gz
Source1: memcached.init
Source2: memcached.sysconfig
Source3: memcached.checker
Source4: memcached.service
Patch0: memcached-makefile.patch
Patch1: memcached-debug.patch
URL: http://www.memcached.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: libevent
%ifarch x86_64
%define enable64 1
%endif

BuildRequires: libevent-devel
BuildRequires: systemd-units

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
# For triggerun
Requires(post): systemd-sysv
Requires(pre):  shadow-utils

# as of 3.5.5-4 selinux has memcache included
Obsoletes: memcached-selinux

%description
memcached is a high-performance, distributed memory object caching system,
generic in nature, but intended for use in speeding up dynamic web
applications by alleviating database load.

%package devel
Summary: Files needed for development using memcached protocol
Group: Development/Libraries
BuildArch: noarch

%description devel
memcached is a high-performance, distributed memory object caching
system, generic in nature, but intended for use in speeding up dynamic
web applications by alleviating database load.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q
%patch0 -p1
#patch1 -p1

%build
# compile with full RELRO
export CFLAGS="%{optflags} -pie -fpie"
export LDFLAGS="-Wl,-z,relro,-z,now"

%{configure} \
	%{?enable64: --enable-64bit} \
	--with-libevent=%{_prefix}

sed -i 's/-Werror/ /' Makefile
%{__make} %{?_smp_mflags}

%install
%{__make} install DESTDIR=%{buildroot} INSTALL="%{__install} -p"

%{__mkdir} -p %{buildroot}%{_sysconfdir}/sysconfig
%{__install} -Dp -m0755 %{SOURCE1} %{buildroot}%{_sbindir}/init.d/%{name}
%{__install} -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
%{__install} -m 755 scripts/%{name}-tool %{buildroot}%{_sbindir}/%{name}-tool
%{__install} -Dp -m0644 scripts/memcached-tool.1 \
			%{buildroot}%{_mandir}/man1/memcached-tool.1
%{__install} -m 755 %{SOURCE3} %{buildroot}%{_sbindir}/%{name}-checkup
%{__install} -Dp -m0644 %{SOURCE4} %{buildroot}%{_unitdir}/memcached.service

%clean
rm -rf %{buildroot}

%post
%systemd_post memcached.service

%preun
%systemd_preun memcached.service

%postun
%systemd_postun_with_restart memcached.service

%files
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/sysconfig/memcached
%{_sbindir}/init.d/memcached
%{_sbindir}/memcached*
%{_mandir}/man1/*.1*
%{_unitdir}/memcached.service

%files devel
%{_includedir}/memcached/*

%changelog
* Sat Apr 07 2018 JoungKyun.Kim <hostmaster@oops.org> 1:1.5.7-1%{?dist}
- udpate 1.5.7
  https://github.com/memcached/memcached/wiki/ReleaseNotes157

* Fri Mar 16 2018 JoungKyun.Kim <hostmaster@oops.org> 1:1.5.6-1%{?dist}
- udpate 1.5.6
  https://github.com/memcached/memcached/wiki/ReleaseNotes156
  https://github.com/memcached/memcached/wiki/ReleaseNotes155
- security issues
  . CVE-2018-1000115 Preventing DDoS amplification attacks using memcached

* Sat Feb 10 2018 JoungKyun.Kim <hostmaster@oops.org> 1:1.5.4-1%{?dist}
- udpate 1.5.4
  https://github.com/memcached/memcached/wiki/ReleaseNotes154
  https://github.com/memcached/memcached/wiki/ReleaseNotes153
  https://github.com/memcached/memcached/wiki/ReleaseNotes152

* Sat Sep 23 2017 JoungKyun.Kim <hostmaster@oops.org> 1:1.5.1-1%{?dist}
- udpate 1.5.1
  https://github.com/memcached/memcached/wiki/ReleaseNotes151

* Thu Aug 24 2017 JoungKyun.Kim <hostmaster@oops.org> 1:1.5.0-1%{?dist}
- update 1.5.0
  https://github.com/memcached/memcached/wiki/ReleaseNotes1437
  https://github.com/memcached/memcached/wiki/ReleaseNotes1438
  https://github.com/memcached/memcached/wiki/ReleaseNotes1439
  https://github.com/memcached/memcached/wiki/ReleaseNotes150
- security issues
  . CVE-2017-9951 Update Remote Code Execution Vulnerability

* Tue Mar 21 2017 JoungKyun.Kim <hostmaster@oops.org> 1:1.4.36-1%{?dist}
- update 1.4.36
  https://github.com/memcached/memcached/wiki/ReleaseNotes1436
  https://github.com/memcached/memcached/wiki/ReleaseNotes1435
  https://github.com/memcached/memcached/wiki/ReleaseNotes1434

* Fri Nov 11 2016 JoungKyun.Kim <hostmaster@oops.org> 1:1.4.33-1%{?dist}
- update 1.4.33
  https://github.com/memcached/memcached/wiki/ReleaseNotes1433
- security issues
  . CVE-2016-8704 Append/Prepend Remote Code Execution Vulnerability
  . CVE-2016-8705 Update Remote Code Execution Vulnerability
  . CVE-2016-8706 SASL Authentication Remote Code Execution Vulnerability

* Sat Oct 29 2016 JoungKyun.Kim <hostmaster@oops.org> 1:1.4.32-1%{?dist}
- update 1.4.32
  https://github.com/memcached/memcached/wiki/ReleaseNotes1432

* Fri Sep 16 2016 JoungKyun.Kim <hostmaster@oops.org> 1:1.4.31-1%{?dist}
- update 1.4.31 on AN3
  https://github.com/memcached/memcached/wiki/ReleaseNotes1425
  https://github.com/memcached/memcached/wiki/ReleaseNotes1426
  https://github.com/memcached/memcached/wiki/ReleaseNotes1427
  https://github.com/memcached/memcached/wiki/ReleaseNotes1428
  https://github.com/memcached/memcached/wiki/ReleaseNotes1429
  https://github.com/memcached/memcached/wiki/ReleaseNotes1430
  https://github.com/memcached/memcached/wiki/ReleaseNotes1431
- Fix memcached unable to bind to an ipv6 address
- Fix display of settings.hot_lru_pct in stats settings
- fix off-by-one in LRU crawler, causing rare segfault
- Fix undefined behavior in vlen check
- Fix ancient binprot bug with sets resulting in OOM errors desycning the protocol.
- allow cachedump'ing of slab 63.

* Thu Nov 12 2015 JoungKyun.Kim <hostmaster@oops.org> 1:1.4.24-1%{?dist}
- update 1.4.24 on AN3

* Thu Feb 27 2014 JoungKyun.Kim <hostmaster@oops.org> 1:1.4.17-1%{?dist}
- update 1.4.17

* Fri Feb 17 2012 JoungKyun.Kim <hostmaster@oops.org> 1:1.4.13-1%{?dist}
- update 1.4.13

* Mon Aug  2 2010 JoungKyun.Kim <hostmaster@oops.org> 10:1.4.5-3%{?dist}
- deviede header file

* Fri Jul 30 2010 JoungKyun.Kim <hostmaster@oops.org> 10:1.4.5-2%{?dist}
- fixed recording of wrong pid file on multiple instance start
- support individual start and stop per port

* Mon Jun 14 2010 JoungKyun.Kim <hostmaster@oops.org> 10:1.4.5-1%{?dist}
- update 1.4.5

* Fri Sep 12 2008 JoungKyun.Kim <hostmaster@oops.org> 2:1.2.6-2
- support multi memcached start in init file
- support memcache process check startup script

* Wed Aug 27 2008 JoungKyun.Kim <hostmaster@oops.org> 1:1.2.6-1
- update 1.2.6

* Fri Jul 25 2008 JoungKyun.Kim <hostmaster@oops.org> 1:1.2.5-1
- initial package
